<?php
namespace Studip\Dockerized\Commands\DB;

use Studip\Dockerized\Config;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputArgument;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Symfony\Component\Console\Style\SymfonyStyle;

final class Port extends Command
{
    protected function configure()
    {
        $this->setName('db:port');
        $this->setDescription('Change exposing port for Database (needs recompile)');
        $this->addArgument(
            'port',
            InputArgument::REQUIRED,
            'Port to use'
        );
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $port = (int) $input->getArgument('port');

        $config = Config::getInstance();
        $io = new SymfonyStyle($input, $output);

        $dbPort = $config->get('db');
        $dbPort['port'] = $port;
        $config->set('db', $dbPort);
        $config->store();

        $io->success("Exposing ports of DB were changed to {$port}");

        return Command::SUCCESS;
    }
}
