<?php
namespace Studip\Dockerized\Commands\Docker;

use Studip\Dockerized\DockerComposeCommand;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\ArrayInput;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

final class Build extends DockerComposeCommand
{
    protected function configure()
    {
        $this->setName('docker:build');
        $this->setDescription('Build containers');
    }

    protected function getDockerComposeCommand(): array
    {
        $dockerRunning = $this->isDockerRunning();
        if ($dockerRunning) {
            $this->createDockerComposeCommand(['down']);
        }

        return ['up', '--no-start'];
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $dockerRunning = $this->isDockerRunning();
        if ($dockerRunning) {
            $this->getApplication()->doRun(
                new ArrayInput(['command' => 'docker:stop']),
                $output
            );
        }

        $result = parent::execute($input, $output);
        if ($result !== Command::SUCCESS || !$dockerRunning) {
            return $result;
        }

        $this->getApplication()->doRun(
            new ArrayInput(['command' => 'docker:start']),
            $output
        );

        return Command::SUCCESS;
    }
}
