<?php
namespace Studip\Dockerized\Commands\Sites;

use Studip\Dockerized\Config;
use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Helper\Table;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

final class Show extends Command
{
    protected function configure()
    {
        $this->setName('site:list');
        $this->setDescription('List all sites');
    }

    protected function execute(InputInterface $input, OutputInterface $output)
    {
        $table = new Table($output);
        //$table->setStyle('compact');

        $table->setHeaders(['Web', 'Local', 'Mount']);

        foreach (Config::getInstance()->get('sites') ?? [] as $key => $site) {
            $table->addRow([$key, $site['source'], $site['mount'] ?? '-']);
        };

        $table->render();

        return Command::SUCCESS;
    }
}