<?php
final class LogParser
{
    private string $filename;

    public function __construct(string $filename)
    {
        $this->filename = $filename;
    }

    public function hasData(): bool
    {
        return file_exists($this->filename)
            && filesize($this->filename) > 0;
    }

    public function entries(): array
    {
        $entries = [];
        $index = -1;

        $fp = fopen($this->filename, 'r');
        while (!feof($fp)) {
            $line = trim(fgets($fp));
            if (strlen($line) === 0) {
                continue;
            }

            $line = str_replace(
                [
                    '/usr/share/nginx/'
                ],
                '',
                $line
            );

            if ($index === -1 || preg_match('/^\[.+]/', $line)) {
                $index += 1;
            }

            if (!isset($entries[$index])) {
                $entries[$index] = '';
            }
            $entries[$index] .= $entries[$index] ? "\n" . $line : $line;
        }

        return array_reverse($entries);
    }
}
